"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DefaultNextApp = exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireDefault(require("react"));

var _app = _interopRequireWildcard(require("next/app"));

var _withParts = _interopRequireDefault(require("../mui/withParts"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var makeNextApp = function makeNextApp(muiTheme, Layout, enableNProgress, enableDefaultCssBaseline) {
  var BaseAppComponent = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : _app["default"];
  var hocs = (0, _withParts["default"])(muiTheme, Layout, enableNProgress, enableDefaultCssBaseline);

  var NextApp =
  /*#__PURE__*/
  function (_BaseAppComponent) {
    _inherits(NextApp, _BaseAppComponent);

    function NextApp() {
      _classCallCheck(this, NextApp);

      return _possibleConstructorReturn(this, _getPrototypeOf(NextApp).apply(this, arguments));
    }

    _createClass(NextApp, [{
      key: "render",
      value: function render() {
        var _this$props = this.props,
            Component = _this$props.Component,
            pageProps = _this$props.pageProps;
        var NewComponent = hocs(Component);
        return _react["default"].createElement(_app.Container, null, _react["default"].createElement(NewComponent, pageProps));
      }
    }], [{
      key: "getInitialProps",
      // inject props made by hoc
      value: function () {
        var _getInitialProps = _asyncToGenerator(
        /*#__PURE__*/
        _regenerator["default"].mark(function _callee(_ref) {
          var Component, ctx, pageProps, ComponentWithInitialProps;
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  Component = _ref.Component, ctx = _ref.ctx;
                  pageProps = {};
                  ComponentWithInitialProps = hocs(Component);

                  if (!ComponentWithInitialProps.getInitialProps) {
                    _context.next = 7;
                    break;
                  }

                  _context.next = 6;
                  return ComponentWithInitialProps.getInitialProps(ctx);

                case 6:
                  pageProps = _context.sent;

                case 7:
                  return _context.abrupt("return", {
                    pageProps: pageProps
                  });

                case 8:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function getInitialProps(_x) {
          return _getInitialProps.apply(this, arguments);
        }

        return getInitialProps;
      }()
    }]);

    return NextApp;
  }(BaseAppComponent);

  return NextApp;
};

var _default = makeNextApp;
exports["default"] = _default;
var DefaultNextApp = makeNextApp();
exports.DefaultNextApp = DefaultNextApp;